"use strict";
{
    const C3 = self.C3;

    C3.Plugins.EMI_INDO_All_Firebase_X.Instance = class All_Firebase_XInstance extends C3.SDKInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst);

            this._ResponseID = "";

            if (properties)
            {

                this._IsDebug = properties[0];
                this._ResponseID = properties[3];

            }

            //  console.log("getElementById: " + this._ResponseID)


            this._debug = "";

            this._userID = "";
            this._isUserSignedIn = false;

            this._userSimpleLeaderboard = "";
            this._SimpleLeaderboardType = "";
            this._SimpleLeaderboardData = [];


            this._Tags = "";


            this._receiverScore = 0;
            this._senderScore = 0;

            this._JsonGetChatHistory = "";
            this._JsonListenToChat = "";


            this._rowBorder = "";
            this._rowPadding = "";
            this._rowBg = "";
            this._fnSanderNm = "";
            this._fnMsg = "";
            this._fnSat = "";
            this._timePos = "";




            this._chatCollection = "";
            this._selectReceiverId = "";
            this._selectReceiverName = "";

            this._messageToView = "";

            this._Candition = C3.Plugins.EMI_INDO_All_Firebase_X.Cnds;

            const self = this;




            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }
            else
            {

                FirebasePlugin.isUserSignedIn(function(isSignedIn)
                {


                    self._isUserSignedIn = isSignedIn;
                    self.Trigger(self._Candition.IsUserSignedIn);

                    if (isSignedIn)
                    {
                        FirebasePlugin.getCurrentUser(function(user)
                        {
                            self._userID = user.uid;
                            self.Trigger(self._Candition.OnUserSignedIn);

                        }, function(error)
                        {
                            self._debug = ("Failed to get current user data: " + error);
                            self.Trigger(self._Candition.OnError);
                        });

                    }


                }, function(error)
                {
                    self._debug = ("Failed to check if user is signed in: " + error);
                    self.Trigger(self._Candition.OnError);
                });
            }



        }

        Release()
        {
            super.Release();
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }


        _AddScore(collection, userId, score, tag)
        {

            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }


            this._chatCollection = collection;

            this._Tags = tag;

            const self = this;

            const senderUserId = userId;
            const scoreToAdd = parseInt(score);

            if (senderUserId && scoreToAdd)
            {

                var senderDocumentId = userId;

                FirebasePlugin.documentExistsInFirestoreCollection(senderDocumentId, collection, function(exists)
                {
                    if (exists)
                    {

                        var senderDocumentFragment = {
                            "userId": senderUserId,
                            "score": scoreToAdd
                        };


                        FirebasePlugin.updateDocumentInFirestoreCollection(senderDocumentId, senderDocumentFragment, collection, true, function()
                        {
                            self._debug = senderUserId;
                            self.Trigger(self._Candition.OnTag);
                        }, function(error)
                        {
                            self._debug = ("Error updating sender's score: " + error);
                            self.Trigger(self._Candition.OnError);
                        });
                    }
                    else
                    {

                        var newSenderDocument = {
                            "userId": senderUserId,
                            "score": scoreToAdd
                        };


                        FirebasePlugin.setDocumentInFirestoreCollection(senderDocumentId, newSenderDocument, collection, true, function()
                        {
                            self._debug = senderUserId;
                            self.Trigger(self._Candition.OnTag);
                        }, function(error)
                        {
                            self._debug = ("Error creating sender's document: " + error);
                            self.Trigger(self._Candition.OnError);
                        });
                    }
                }, function(error)
                {
                    self._debug = ("Error checking sender document existence: " + error);
                    self.Trigger(self._Candition.OnError);
                });
            }
            else
            {
                self._debug = ("Please fill in all fields.");
                self.Trigger(self._Candition.OnError);
            }

        }


        _TransferScore(collection, userId, receiver, scores, tag)
        {

            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }


            this._chatCollection = collection;

            this._Tags = tag;

            const self = this;

            const senderUserId = userId;
            const receiverUserId = receiver;
            const score = parseInt(scores);


            if (senderUserId && receiverUserId && score)
            {
                const senderDocumentId = userId;
                const receiverDocumentId = receiver;

                FirebasePlugin.fetchDocumentInFirestoreCollection(senderDocumentId, collection, function(senderDocument)
                {
                    if (senderDocument)
                    {
                        var senderScore = senderDocument.score || 0;

                        if (senderScore >= score)
                        {
                            senderScore -= score;

                            var senderDocumentFragment = {
                                "userId": senderUserId,
                                "score": senderScore
                            };
                            FirebasePlugin.updateDocumentInFirestoreCollection(senderDocumentId, senderDocumentFragment, collection, true, function()
                            {
                                self._debug = ("Successfully reduced the score of the sender with ID=" + senderUserId);
                                // self._senderUserId = senderUserId;
                                self._senderScore = senderScore;

                                FirebasePlugin.fetchDocumentInFirestoreCollection(receiverDocumentId, collection, function(receiverDocument)
                                {
                                    if (receiverDocument)
                                    {
                                        var receiverScore = receiverDocument.score || 0;
                                        receiverScore += score;

                                        var receiverDocumentFragment = {
                                            "userId": receiverUserId,
                                            "score": receiverScore
                                        };
                                        FirebasePlugin.updateDocumentInFirestoreCollection(receiverDocumentId, receiverDocumentFragment, collection, true, function()
                                        {
                                            self._debug = ("Successfully added scores to recipients with ID=" + receiverUserId);
                                            // self._receiverUserId = receiverUserId;
                                            self._receiverScore = receiverScore;
                                            self.Trigger(self._Candition.OnTag);
                                        }, function(error)
                                        {
                                            dself._debug = ("Error updating receiver's score: " + error);
                                            self.Trigger(self._Candition.OnError);
                                        });
                                    }
                                    else
                                    {
                                        self._debug = ("Recipient document with ID=" + receiverUserId + " not found.");
                                        self.Trigger(self._Candition.OnError);
                                    }
                                }, function(error)
                                {
                                    self._debug = ("Error fetching receiver document: " + error);
                                    self.Trigger(self._Candition.OnError);
                                });
                            }, function(error)
                            {
                                self._debug = ("Error updating sender's score: " + error);
                                self.Trigger(self._Candition.OnError);
                            });
                        }
                        else
                        {
                            self._debug = ("The sender's score is not enough to send this much score.");
                            self.Trigger(self._Candition.OnError);
                        }
                    }
                    else
                    {
                        self._debug = ("The sender document with ID=" + senderUserId + " was not found.");
                        self.Trigger(self._Candition.OnError);
                    }
                }, function(error)
                {
                    self._debug = ("Error fetching sender document: " + error);
                    self.Trigger(self._Candition.OnError);
                });
            }
            else
            {
                self._debug = ("Please fill in all fields.");
                self.Trigger(self._Candition.OnError);
            }

        }


        _CreateGroup(collection, groupId, userId, displayName, tag)
        {


            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }

            this._chatCollection = collection;
            this._Tags = tag;
            const self = this;

            FirebasePlugin.fetchDocumentInFirestoreCollection(groupId, collection,

            function(groupData)
            {
                if (groupData)
                {
                    var members = groupData.members || [];
                    var memberNames = groupData.memberNames || {};
                    memberNames[userId] = displayName || "Anonymous";

                    if (!members.includes(userId))
                    {
                        members.push(userId);
                    }
                    groupData.members = members;
                    groupData.memberNames = memberNames;

                    FirebasePlugin.updateDocumentInFirestoreCollection(groupId, groupData, collection, true,

                    function()
                    {
                        self._debug = "Group updated successfully";
                        self.Trigger(self._Candition.OnTag);
                    },

                    function(error)
                    {
                        self._debug = "Error updating group: " + error;
                        self.Trigger(self._Candition.OnError);
                    });
                }
                else
                {
                    var newGroupData = {
                        chatID: groupId,
                        members: [userId],
                        memberNames: {[userId]: displayName || "Anonymous"
                        },
                        recentMessageText: "",
                        recentMessageSentAt: "",
                        recentMessageSendBy: "",
                        readBy: [],
                        chatTitle: groupId,
                        chatType: collection
                    };

                    FirebasePlugin.setDocumentInFirestoreCollection(newGroupData.chatID, newGroupData, collection, true,

                    function()
                    {
                        console.log("Group chat created successfully");
                        self.Trigger(self._Candition.OnTag);
                    },

                    function(error)
                    {
                        self._debug = "Error creating group chat: " + error;
                        self.Trigger(self._Candition.OnError);
                    });
                }
            },

            function(error)
            {
                self._debug = "Error fetching group data: " + error;
                self.Trigger(self._Candition.OnError);
            });


        }







        _SendMessage(collection, groupId, senderId, displayName, text, tag)
        {


            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }


            this._chatCollection = collection;

            this._Tags = tag;

            const self = this;

            var messageID = "message_" + Date.now();

            var senderName = displayName || "Anonymous";

            var newMessageData = {
                chatID: groupId,
                messageID: messageID,
                senderID: senderId,
                senderName: senderName,
                messageText: text,
                sentAt: new Date().toISOString()
            };

            FirebasePlugin.setDocumentInFirestoreCollection(newMessageData.messageID, newMessageData, collection, true, function()
            {

                updateGroupWithMessage(newMessageData);
                self._debug = ("Message sent successfully");
                self.Trigger(self._Candition.OnTag);

            }, function(error)
            {
                self._debug = ("Error sending message: " + error);
                self.Trigger(self._Candition.OnError);
            });



            function updateGroupWithMessage(messageData)
            {
                FirebasePlugin.fetchDocumentInFirestoreCollection(messageData.chatID, collection,

                function(groupData)
                {
                    if (groupData)
                    {
                        groupData.recentMessageText = messageData.messageText;
                        groupData.recentMessageSentAt = messageData.sentAt;
                        groupData.recentMessageSendBy = messageData.senderID;
                        groupData.recentMessageSendByName = messageData.senderName;
                        FirebasePlugin.updateDocumentInFirestoreCollection(messageData.chatID, groupData, collection, true,

                        function()
                        {
                            self._debug = ("Group data updated with recent message" + JSON.stringify(groupData));

                        },

                        function(error)
                        {

                            self._debug = ("Error updating group data: " + error);
                            self.Trigger(self._Candition.OnError);
                        });
                    }
                    else
                    {

                        self._debug = ("Group data not found for chatID: " + messageData.chatID);
                        self.Trigger(self._Candition.OnError);
                    }
                },

                function(error)
                {

                    self._debug = ("Error fetching group data: " + error);
                    self.Trigger(self._Candition.OnError);
                });
            }


        }




        _GetChatHistory(collection, groupId, tag)
        {

            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }

            this._Tags = tag;

            const self = this;

            const chatID = groupId;
            const elmId = this._ResponseID;


            const a = this._rowBorder || "1px solid #ccc";
            const b = this._rowPadding || "2%";
            const c = this._rowBg || "#f9f9f9";
            const d = this._fnSanderNm || "8px";
            const e = this._fnMsg || "14px";
            const f = this._fnSat || "8px";
            const g = this._timePos || "right";


            FirebasePlugin.fetchFirestoreCollection(collection, [['where', 'chatID', '==', chatID]],

            function(messages)
            {
                var responseArea = document.getElementById(elmId);

                var width = responseArea.getBoundingClientRect().width + window.scrollX;
                var height = responseArea.getBoundingClientRect().height + window.scrollY;

                responseArea.innerHTML = "";
                responseArea.style.overflowY = "scroll";
                responseArea.style.width = width + 'px';
                responseArea.style.height = height + 'px';



                for (var messageId in messages)
                {
                    if (messages.hasOwnProperty(messageId))
                    {
                        var message = messages[messageId];
                        var messageDiv = document.createElement("div");
                        messageDiv.style.border = a;
                        messageDiv.style.padding = b;
                        messageDiv.style.backgroundColor = c;

                        var senderNameDiv = document.createElement("div");
                        senderNameDiv.textContent = (message.senderName || "Anonymous");
                        senderNameDiv.style.fontSize = d;

                        messageDiv.appendChild(senderNameDiv);

                        var messageTextDiv = document.createElement("div");
                        messageTextDiv.textContent = message.messageText;
                        messageTextDiv.style.fontSize = e;

                        messageDiv.appendChild(messageTextDiv);

                        var sentAtDiv = document.createElement("div");
                        var localSentAt = new Date(message.sentAt).toLocaleString('en-US',
                        {
                            weekday: 'long',
                            hour: 'numeric',
                            minute: '2-digit',
                            hour12: true
                        });
                        sentAtDiv.textContent = localSentAt;
                        sentAtDiv.style.fontSize = f;
                        sentAtDiv.style.textAlign = g;

                        messageDiv.appendChild(sentAtDiv);

                        responseArea.appendChild(messageDiv);
                        responseArea.scrollTop = responseArea.scrollHeight;

                    }
                }

                self._JsonGetChatHistory = (JSON.stringify(messages));
                self._debug = (JSON.stringify(messages));
                self.Trigger(self._Candition.OnTag);


            }, function(error)
            {
                self._debug = ("Error fetching group chat history: " + error);
                self.Trigger(self._Candition.OnError);
            });


        }


        _ListenToChat(collection, groupId, tag)
        {


            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }

            this._Tags = tag;

            const self = this;

            const chatID = groupId;

            const elmId = this._ResponseID;

            const a = this._rowBorder || "1px solid #ccc";
            const b = this._rowPadding || "2%";
            const c = this._rowBg || "#f9f9f9";
            const d = this._fnSanderNm || "8px";
            const e = this._fnMsg || "14px";
            const f = this._fnSat || "8px";
            const g = this._timePos || "right";

            FirebasePlugin.listenToDocumentInFirestoreCollection(

            function(event)
            {
                switch (event.eventType)
                {
                    case "change":
                        if (event.snapshot)
                        {
                            let newMessage = event.snapshot;
                            var messageDiv = document.createElement("div");
                            messageDiv.style.border = a;
                            messageDiv.style.padding = b;
                            messageDiv.style.backgroundColor = c;

                            var senderNameDiv = document.createElement("div");
                            senderNameDiv.textContent = (newMessage.recentMessageSendByName || "Anonymous");
                            senderNameDiv.style.fontSize = d;
                            messageDiv.appendChild(senderNameDiv);

                            var messageTextDiv = document.createElement("div");
                            messageTextDiv.textContent = newMessage.recentMessageText;
                            messageTextDiv.style.fontSize = e;
                            messageDiv.appendChild(messageTextDiv);

                            var sentAtDiv = document.createElement("div");
                            var localSentAt = new Date(newMessage.recentMessageSentAt).toLocaleString('en-US',
                            {
                                weekday: 'long',
                                hour: 'numeric',
                                minute: '2-digit',
                                hour12: true
                            });
                            sentAtDiv.textContent = localSentAt;
                            sentAtDiv.style.fontSize = f;
                            sentAtDiv.style.textAlign = g;
                            messageDiv.appendChild(sentAtDiv);

                            var responseArea = document.getElementById(elmId);

                            var width = responseArea.getBoundingClientRect().width + window.scrollX;
                            var height = responseArea.getBoundingClientRect().height + window.scrollY;


                            responseArea.style.overflowY = "scroll";
                            responseArea.style.width = width + 'px';
                            responseArea.style.height = height + 'px';
                            responseArea.scrollTop = responseArea.scrollHeight;
                            responseArea.appendChild(messageDiv);

                            self._debug = (JSON.stringify(newMessage));
                            self._JsonListenToChat = (JSON.stringify(newMessage));
                            self.Trigger(self._Candition.OnTag);
                        }
                        break;
                }
            },

            function(error)
            {

                self._debug = ("Error listening to group chat: " + error);
                self.Trigger(self._Candition.OnError);
            },
            chatID,
            collection,
            false);

        }






        _CreateEmailAndPassword(email, password, tag)
        {

            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }
            const self = this;
            this._Tags = tag;

            FirebasePlugin.createUserWithEmailAndPassword(email, password, function()
            {
                self._debug = ("Successfully created email/password-based user account");
                self.Trigger(self._Candition.OnTag);

            }, function(error)
            {
                self._debug = ("Failed to create email/password-based user account", error);
                self.Trigger(self._Candition.OnError);

            });


        }




        _SigninuserEmailPassword(email, password, tag)
        {


            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }

            const self = this;
            this._Tags = tag;

            FirebasePlugin.signInUserWithEmailAndPassword(email, password, function()
            {
                self._debug = ("Successfully signed in");
                self.Trigger(self._Candition.OnTag);
            }, function(error)
            {

                self._debug = ("Failed to sign in", error);
                self.Trigger(self._Candition.OnError);

            });


        }


        _SigninUserAnonymously(tag)
        {
            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }
            const self = this;
            this._Tags = tag;

            FirebasePlugin.signInUserAnonymously(function()
            {
                self._debug = ("Successfully signed in");
                self.Trigger(self._Candition.OnTag);
            }, function(error)
            {
                self._debug = ("Failed to sign in", error);
                self.Trigger(self._Candition.OnError);
            });


        }




        _CreateSimpleLeaderboard(collection, userId, name, score, tag)
        {

            if (typeof FirebasePlugin == 'undefined')
            {
                return;
            }

            this._Tags = tag;
            const userScore = parseInt(score);

            const self = this;

            if (!userId || !userScore)
            {
                self._debug = ("error post data false");
                self.Trigger(self._Candition.OnError);
                return;
            }

            FirebasePlugin.documentExistsInFirestoreCollection(userId, collection, function(exists)
            {
                if (exists)
                {
                    var documentId = userId;
                    var documentFragment = {
                        "userId": userId,
                        "name": name,
                        "score": userScore
                    };
                    FirebasePlugin.updateDocumentInFirestoreCollection(documentId, documentFragment, collection, function()
                    {
                        self._debug = ("Successfully updated score for user " + userId);
                        self._SimpleLeaderboardData = [];
                        self.Trigger(self._Candition.OnTag);

                    }, function(error)
                    {
                        self._debug = ("Error updating score: " + error);
                        self.Trigger(self._Candition.OnError);
                    });
                }
                else
                {
                    var documentId = userId;
                    var document = {
                        "userId": userId,
                        "name": name,
                        "score": userScore
                    };
                    FirebasePlugin.setDocumentInFirestoreCollection(documentId, document, collection, function()
                    {

                        self._debug = ("Successfully added score for user " + userId);
                        self._SimpleLeaderboardData = [];
                        self.Trigger(self._Candition.OnTag);

                    }, function(error)
                    {
                        self._debug = ("Error setting document: " + error);
                        self.Trigger(self._Candition.OnError);
                    });
                }
            }, function(error)
            {
                self._debug = ("Error checking document existence: " + error);
                self.Trigger(self._Candition.OnError);
            });

        }




        _GetSimpleLeaderboard(collection, limit, tag)
        {


            if (typeof FirebasePlugin == 'undefined')
            {
                return;
            }

            this._Tags = tag;

            const self = this;

            var filters = [
                ['orderBy', 'score', 'desc'],
                ['limit', limit]
            ];

            FirebasePlugin.fetchFirestoreCollection(collection, filters, function(documents)
            {


                var data = [];

                for (var key in documents)
                {
                    if (documents.hasOwnProperty(key))
                    {
                        var document = documents[key];

                        data.push(
                        {
                            name: document.name,
                            score: document.score
                        });

                    }
                }


                if (data.length > 0)
                {
                    self._SimpleLeaderboardData = data;
                    self._debug = (JSON.stringify(data));
                    self.Trigger(self._Candition.OnTag);

                }
                else
                {
                    self._debug = ("No data available for leaderboard.");
                    self.Trigger(self._Candition.OnError);
                }

            }, function(error)
            {
                var errorMessage = "Error fetching leaderboard: " + error;
                self._debug = (errorMessage);
                self.Trigger(self._Candition.OnError);
            });

        }



        _ShowSimpleLeaderboard(id, hn, hc, shc, snc, ssc)
        {
            const self = this;

            var styleHeaderCell = JSON.parse(shc);
            var styleNameCell = JSON.parse(snc);
            var styleScoreCell = JSON.parse(ssc);

            function createStyledElement(tag, textContent, styles)
            {
                var element = document.createElement(tag);
                element.textContent = textContent;

                for (var style in styles)
                {
                    if (styles.hasOwnProperty(style))
                    {
                        element.style[style] = styles[style];
                    }
                }

                return element;
            }

            var leaderboardDiv = document.getElementById(id);
            var headerRow = document.createElement("tr");
            var headerNameCell = createStyledElement("th", hn, styleHeaderCell);
            var headerScoreCell = createStyledElement("th", hc, styleHeaderCell);
            headerRow.appendChild(headerNameCell);
            headerRow.appendChild(headerScoreCell);
            headerRow.style.display = "none";
            while (leaderboardDiv.firstChild)
            {
                leaderboardDiv.removeChild(leaderboardDiv.firstChild);
            }
            var table = document.createElement("table");
            var width = leaderboardDiv.offsetWidth;
            var height = leaderboardDiv.offsetHeight;

            table.style.width = width + 'px';
            table.style.height = height + 'px';
            table.appendChild(headerRow);
            leaderboardDiv.appendChild(table);
            self._SimpleLeaderboardData.forEach(function(item)
            {
                var row = document.createElement("tr");
                var nameCell = createStyledElement("td", item.name, styleNameCell);
                var scoreCell = createStyledElement("td", item.score, styleScoreCell);
                row.appendChild(nameCell);
                row.appendChild(scoreCell);
                table.appendChild(row);
                headerRow.style.display = "";
            });
        }


        _SignOutUser(tag)
        {

            if (typeof FirebasePlugin === 'undefined')
            {
                return;
            }
            const self = this;
            this._Tags = tag;

            FirebasePlugin.signOutUser(function()
            {
                self._debug = ("User signed out");
                self.Trigger(self._Candition.OnTag);
            }, function(error)
            {
                self._debug = ("Failed to sign out user: " + error);
                self.Trigger(self._Candition.OnError);
            });


        }


        GetDebuggerProperties()
        {
            return [
            {
                title: "All_Firebase_X",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }

        // timeline support
        GetPropertyValueByIndex(index)
        {
            return 0;
        }

        SetPropertyValueByIndex(index, value)
        {
            //set property value here
        }
    };
}